SystemOrganization addCategory: #'Mondrian-Pharo-Morphic'!

!BalloonCanvas methodsFor: '*mondrian-pharo-morphic' stamp: ''!
drawArrowHead: anArray fill: fillColor borderWidth: anInteger borderColor: borderColor
     self ensuredEngine drawPolygon: anArray fill: fillColor borderWidth: anInteger borderColor: borderColor transform: transform. ! !

!BalloonCanvas methodsFor: '*mondrian-pharo-morphic' stamp: ''!
drawDashedPath: anArray borderWidth: borderWidth borderColor: borderColor
    | delta fromPoint toPoint c b a alpha deltaX deltaY length pointA pointB |
    pointA := anArray first.
    pointB := anArray second.

    "Kosinussatz"
    c := pointB dist: pointA.
    b := pointB y - pointA y.
    a := pointB x - pointA x.
    
    a = 0 ifTrue: [delta := 0@10]. "Special case: horizonal line"
    b = 0 ifTrue: [delta := (a sign * 10)@0]. "Special case: vertical line"
    delta ifNil: [
        alpha := (a / c) arcSin.
        deltaX := 10 * (alpha sin).
        deltaY := 10 * (alpha cos) * b sign.
        delta := deltaX @ deltaY.
    ].

    fromPoint := pointA.
    toPoint := pointA + delta.
    length := 10.
    [length <= c] whileTrue: [
        self drawPath: {fromPoint. toPoint} borderWidth: borderWidth borderColor: borderColor.
        fromPoint := toPoint + (0.5 * delta).
        toPoint :=fromPoint + delta.
        length := length + 5 + 10.
    ].

	"Add final stroke" 
    (length - 10) < c ifTrue: [self drawPath: {fromPoint. pointB} borderWidth: borderWidth borderColor: borderColor]. ! !

!BalloonCanvas methodsFor: '*mondrian-pharo-morphic' stamp: ''!
drawPath: anArray borderWidth: borderWidth borderColor: borderColor
	self ensuredEngine
		drawPolygon: anArray
		fill: nil
		borderWidth: borderWidth
		borderColor: borderColor
		transform: transform! !

!BalloonCanvas methodsFor: '*mondrian-pharo-morphic' stamp: ''!
line: startPoint to: endPoint
    self line: startPoint to: endPoint width: 1 color: Color black.! !

!BalloonCanvas methodsFor: '*mondrian-pharo-morphic' stamp: ''!
transform
	^ transform! !

!MOAnnouncer methodsFor: '*mondrian-pharo-morphic' stamp: ''!
noPopup
	self  
		unsubscribeForEvent: MOMouseEnter;
		unsubscribeForEvent: MOMouseLeave.! !

!MOAnnouncer methodsFor: '*mondrian-pharo-morphic' stamp: ''!
popupText
	"open a popup text when the mouse enter a node"

	self popupText: [:each | each]! !

!MOAnnouncer methodsFor: '*mondrian-pharo-morphic' stamp: ''!
popupText: aBlock
	^ self popupText: aBlock delay: 500! !

!MOAnnouncer methodsFor: '*mondrian-pharo-morphic' stamp: 'BenComan 4/26/2012 23:22'!
popupText: aBlock delay: ms
	"open a popup text when the mouse enter a node"

	self popupView: [ :el :myView |
		myView shape rectangle.
		myView node: 'popup' forIt: [
			| popupText |
			popupText := 	[aBlock value: el ] 
								on: Error do: [ el asString ].
			myView shape label.
			myView node: popupText ].
	] delay: ms
! !

!MOAnnouncer methodsFor: '*mondrian-pharo-morphic' stamp: ''!
popupView: aBlock
	self popupView: aBlock delay: 100! !

!MOAnnouncer methodsFor: '*mondrian-pharo-morphic' stamp: ''!
popupView: aBlock delay: ms
	"open a popup text when the mouse enter a node"
	^ self popupView: aBlock delay: ms zoomedInBy: 1! !

!MOAnnouncer methodsFor: '*mondrian-pharo-morphic' stamp: 'AlexandreBergel 3/27/2012 08:38'!
popupView: aBlock delay: ms zoomedInBy: aSymbolOrABlock
	"open a popup text when the mouse enter a node"

	"Yeah, this method is a bit scary"
	self unsubscribeForEvent: MOMouseEnter.
	self unsubscribeForEvent: MOMouseLeave.

	self subscribe: MOMouseEnter do: 
		[:ann | 
			ann element resetMetricCaches.
			(ann hasElement)
				ifTrue: [
					[ | oldPosition view newCanvas relativePosition |
					 oldPosition := ActiveHand position.
					 (Delay forMilliseconds: ms) wait.
					
					 "we compute the relative position since ActiveHand return an absolute location"
					 relativePosition := ann position - oldPosition + ActiveHand position.
					
					 "We check if we are in the same node, if yes, then we evaluate the view"
					(ann root notNil and: [(ann root elementAt: relativePosition) == ann current]) ifTrue: 
						[ view := MOViewRenderer new. 
						  aBlock value: ann element model value: view.
						  newCanvas := MOPopup 
											showView: view 
											zoomedInBy: (aSymbolOrABlock moValue: ann model).
						  ann element popup: newCanvas. ] ] fork.
					]
				ifFalse: [ann element popup ifNotNil: [:v | v delete]. MOPopup remove] ].

	self subscribe: MOMouseLeave do: 
		[:ann | 
			ann element resetMetricCaches.
			ann element removePopupIfExist. MOPopup remove ].
! !

!MOAnnouncer methodsFor: '*mondrian-pharo-morphic' stamp: ''!
popupView: aBlock zoomedInBy: aSymbolOrABlock
	self popupView: aBlock delay: 100 zoomedInBy: aSymbolOrABlock! !

Object subclass: #MOBrowser
	instanceVariableNames: 'canvas root userCommands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Pharo-Morphic'!

!MOBrowser methodsFor: 'commands' stamp: ''!
addUserCommand: aCommand
	self userCommands add: aCommand! !

!MOBrowser methodsFor: 'accessing' stamp: ''!
canvas
	^ canvas! !

!MOBrowser methodsFor: 'morphic' stamp: ''!
exportAsBMP
	self canvas exportAsBMP! !

!MOBrowser methodsFor: 'morphic' stamp: ''!
exportAsGIF
	self canvas exportAsGIF! !

!MOBrowser methodsFor: 'morphic' stamp: ''!
exportAsHTML
	self canvas exportAsHTML! !

!MOBrowser methodsFor: 'morphic' stamp: ''!
exportAsPNG
	self canvas exportAsPNG! !

!MOBrowser methodsFor: 'morphic' stamp: ''!
exportAsSVG
	self canvas exportAsSVG! !

!MOBrowser methodsFor: 'morphic' stamp: ''!
exportAsTikz
	self canvas exportAsTikz! !

!MOBrowser methodsFor: 'morphic' stamp: ''!
exportAsXML
	self canvas exportAsXML! !

!MOBrowser methodsFor: 'morphic' stamp: ''!
exportMenu
	| menuMorph |
	menuMorph := MenuMorph new.
	menuMorph 
				add: 'Export as PNG'
				target: self
				selector: #exportAsPNG.
	menuMorph 
				add: 'Export as BMP'
				target: self
				selector: #exportAsBMP.
	menuMorph 
				add: 'Export as GIF'
				target: self
				selector: #exportAsGIF.
				
	menuMorph 
				add: 'Export as XML'
				target: self
				selector: #exportAsXML.

	menuMorph 
				add: 'Export as SVG'
				target: self
				selector: #exportAsSVG.
	menuMorph 
				add: 'Export as HTML'
				target: self
				selector: #exportAsHTML.

	menuMorph 
				add: 'Export as Tikz'
				target: self
				selector: #exportAsTikz.
	

	^ menuMorph! !

!MOBrowser methodsFor: 'morphic' stamp: ''!
initializeButtonsIn: aWin

	| dock buttons tools offset |
	dock := aWin newToolDockingBar.
	buttons := OrderedCollection new.
	buttons add:( (aWin
			newButtonFor: self root
			getState: #isZoomOn
			action: #increaseZoom
			arguments: #()			
			getEnabled: nil
			labelForm: MondrianIcons mondrianZoomIn 
			help: 'Zoom in') 
			valueOfProperty: #noBorder ifAbsentPut: [true];
			valueOfProperty: #noFill ifAbsentPut: [true];
			yourself).
	buttons add: ((aWin
			newButtonFor: self root
			getState: #isZoomOn
			action: #decreaseZoom
			arguments: #()			
			getEnabled: nil
			labelForm: MondrianIcons mondrianZoomOut
			help: 'Zoom out') 
			valueOfProperty: #noBorder ifAbsentPut: [true];
			valueOfProperty: #noFill ifAbsentPut: [true];
			yourself).

	self userCommands do: [:assoc |
		| title block |
		title := assoc first.
		block := assoc second.
		buttons add: (aWin
				newButtonFor: [ :aRoot | block value: aRoot ] 
				getState: #returnTrue
				action: #value:
				arguments: {self root}
				getEnabled: nil
				label: title
				help: title)
	].
	
	tools := aWin newToolbar: buttons.
	dock 
			add: 'Export' translated
			font: aWin theme menuBarFont
			icon: nil
			help: 'Export' translated
			subMenu: self exportMenu.
	dock addMorphBack: tools.
	offset := dock minExtent y.
	aWin 
		addMorph: dock
		fullFrame: (LayoutFrame 
					fractions: (0 @ 0 corner: 1 @ 0)
					offsets: (0 @ 0 corner: 0 @ offset))
"
	| zoomIncButton zoomDecButton |
	zoomIncButton := PluggableButtonMorph
				on: self root
				getState: #isZoomOn
				action: #increaseZoom
				label: #zoomIncLabel.
	aWindow 
		addMorph: zoomIncButton
		fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 0.5 @ 0) offsets: (0 @ 0 corner: 0 @ 24)).

	zoomDecButton := PluggableButtonMorph
				on: self root
				getState: #isZoomOn
				action: #decreaseZoom
				label: #zoomDecLabel.
	aWindow 
		addMorph: zoomDecButton
		fullFrame: (LayoutFrame fractions: (0.5 @ 0 corner: 1 @ 0) offsets: (0 @ 0 corner: 0 @ 24)).
"! !

!MOBrowser methodsFor: 'morphic' stamp: ''!
open
	^ self open: 'Mondrian Canvas'! !

!MOBrowser methodsFor: 'morphic' stamp: ''!
open: windowLabel
	"The canvas needs to be accessed from outside, especially by the ViewRenderer. This is necessary for sharing the announcer between the canvas and the view"
	| window pane |
	window := StandardWindow labelled: windowLabel.
	window model: self.
	window extent: 640 @ 480.
		
	pane := ScrollPane new.
	
	canvas := MOCanvas on: self root.
	self initializeButtonsIn: window.

	pane scroller addMorph: canvas.
	window 
		addMorph: pane
		fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1) offsets: (0 @ 26 corner: 0 @ 0)).

	window openInWorld.
	canvas updateBounds.
	^ window! !

!MOBrowser methodsFor: 'accessing' stamp: ''!
root
	^ root! !

!MOBrowser methodsFor: 'accessing' stamp: ''!
root:  aMORoot 
	root := aMORoot! !

!MOBrowser methodsFor: 'morphic' stamp: ''!
userCommands
	userCommands ifNil: [ userCommands := OrderedCollection new ].
	^ userCommands! !

!MOBrowser methodsFor: 'morphic' stamp: ''!
windowIsClosing
	canvas root allNodesDo: [ :n | n interaction stopProcesses ]! !

Object subclass: #MOPopup
	instanceVariableNames: ''
	classVariableNames: 'TooltipBalloon'
	poolDictionaries: ''
	category: 'Mondrian-Pharo-Morphic'!

!MOPopup classSide methodsFor: 'instance creation' stamp: ''!
remove
	TooltipBalloon ifNotNil: [ TooltipBalloon delete ].
	MOPopupViewCanvas allInstances do: [:canv| canv delete].! !

!MOPopup classSide methodsFor: 'instance creation' stamp: ''!
show: msgString

	self remove.
	TooltipBalloon := (UITheme builder newBalloonHelp: msgString for: World activeHand)
		popUpFor: (Morph new) hand:  World activeHand.

	^ TooltipBalloon
! !

!MOPopup classSide methodsFor: 'instance creation' stamp: ''!
showView: view
	^ self showView: view zoomedInBy: 1! !

!MOPopup classSide methodsFor: 'instance creation' stamp: ''!
showView: view zoomedInBy: aValue
	| morph mouseOrigin deltaX deltaY newMorphBounds |
	self remove.
	morph := MOCanvas on: view root.
	aValue ~= 1 
		ifTrue: [ view root increaseZoomBy: aValue ].
	morph openInWorld.
	mouseOrigin := ActiveHand bounds origin.
	deltaX := 10.
	deltaY := 0.
	(mouseOrigin x + morph bounds width > World bounds width)
		ifTrue: [ deltaX := deltaX negated -  morph bounds width ].
	(mouseOrigin y + morph bounds height > World bounds height)
		ifTrue: [ deltaY := deltaY -  morph bounds height ].

	newMorphBounds := (morph bounds origin translatedBy: mouseOrigin) extent: (morph bounds extent +(15@15)).
	newMorphBounds := newMorphBounds translateBy: (deltaX @ deltaY).
	
	newMorphBounds origin x < 0
	ifTrue:[ newMorphBounds:= newMorphBounds translateBy: (newMorphBounds origin x negated @ 0) ].
	newMorphBounds origin y < 0
	ifTrue:[ newMorphBounds:= newMorphBounds translateBy: (0 @ newMorphBounds origin y negated) ].
	
	morph bounds: newMorphBounds.
	TooltipBalloon := morph.
	^ morph! !

!MORoot methodsFor: '*mondrian-pharo-morphic' stamp: 'AlexandreBergel 4/15/2012 21:17'!
decreaseZoomBy: aValue

	self resetFormCacheRecursively.
	self nodesDo: [:node | node decreaseZoomBy: aValue ].
	self edgesDo: [:edge | edge resetCache].
	self announce: MOZoomEvent decrease.
	self updateWindow! !

!MORoot methodsFor: '*mondrian-pharo-morphic' stamp: 'AlexandreBergel 4/15/2012 21:17'!
increaseZoomBy: aValue

	self resetFormCacheRecursively.
	self nodesDo: [:node | node increaseZoomBy: aValue ].
	self edgesDo: [:edge | edge resetCache].
	self announce: MOZoomEvent increase.
	self updateWindow! !

!MORoot methodsFor: '*mondrian-pharo-morphic' stamp: 'BenComan 5/11/2012 00:25'!
updateWindow
	"Refresh the content of the window. This happens when some shape change for example"
"	self resetFormCacheRecursively."
	
	"We notify the morphic framework that the canvas needs to be redrawn"
	self canvas changed.
"	self announcer announce: MOContentChanged new.
"! !

Morph subclass: #MOCanvas
	instanceVariableNames: 'currentPosition lastClickPosition lastClickTimestamp root announcer lastEnteredGraphElement rubberBandStart rubberBandEnd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Pharo-Morphic'!

!MOCanvas commentStamp: 'Alexandre.Bergel 2/2/2009 11:05' prior: 0!
Comment by Alexandre Bergel (Feb 2, 2009)

A MOCanvas is the graphical component embedded in a MOBrowser. Figures and nodes are displayed in it.

Instance Variables
	announce:		<Announcer>
	currentElement:		<Object>
	currentPosition:		<Object>
	graph:		<Object>
	lastClickPosition:		<Object>
	lastClickTimestamp:		<Object>
	selected:		<Object>

announce
	- Instance of Announcer. The reference must be obtained from the view

currentElement
	- xxxxx

currentPosition
	- xxxxx

graph
	- xxxxx

lastClickPosition
	- xxxxx

lastClickTimestamp
	- xxxxx

selected
	- xxxxx
!

!MOCanvas classSide methodsFor: 'instance-creation' stamp: ''!
on: aMORoot
	^ self new root: aMORoot! !

!MOCanvas classSide methodsFor: 'instance-creation' stamp: ''!
openOn: aMORoot
	^ (self on: aMORoot) openInHand! !

!MOCanvas methodsFor: 'announce' stamp: ''!
announce: anAnnouncement
"Transcript show: 'debug: ', anAnnouncement printString; cr."

	anAnnouncement element isNil ifFalse: [
		anAnnouncement element announcer announce: anAnnouncement ].
	self announcer announce: anAnnouncement.! !

!MOCanvas methodsFor: 'announce' stamp: ''!
announcer

	^ announcer ifNil: [announcer := MOAnnouncer new].! !

!MOCanvas methodsFor: 'error management' stamp: ''!
disableErrorFlag
	Smalltalk removeKey: #MondrianError ifAbsent: []! !

!MOCanvas methodsFor: 'drawing' stamp: 'BenComan 5/1/2012 01:11'!
drawOn: aCanvas 
	
	aCanvas translateBy: self bounds origin during: [:c |
	 self root acceptVisitor: (MOMorphPainterVisitor newCanvas:  c).
	].

	rubberBandStart ifNotNil: [ aCanvas line: rubberBandStart to: rubberBandEnd width: 1 color: Color red. ]
	! !

!MOCanvas methodsFor: 'export' stamp: ''!
exportAsBMP
	^ self interactiveExportWith: BMPReadWriter extension: '.bmp'! !

!MOCanvas methodsFor: 'export' stamp: ''!
exportAsGIF
	^ self interactiveExportWith: GIFReadWriter extension: '.gif'! !

!MOCanvas methodsFor: 'export' stamp: ''!
exportAsJPEG
	^ self interactiveExportWith: JPEGReadWriter extension: '.jpeg'! !

!MOCanvas methodsFor: 'export' stamp: ''!
exportAsPNG

	^ self interactiveExportWith: PNGReadWriter extension: '.png'! !

!MOCanvas methodsFor: 'export' stamp: ''!
exportWith: imageWriterClass fullname: fullName

	imageWriterClass
		putForm: self imageForm
		onFileNamed: fullName! !

!MOCanvas methodsFor: 'export' stamp: ''!
exportWith: imageWriterClass onStream: stream

	imageWriterClass
		putForm: self imageFormForExport
		onStream: stream! !

!MOCanvas methodsFor: 'morph' stamp: ''!
externalName
	^ 'Mondrian-', Date today yyyymmdd, '-', Time now hhmm24! !

!MOCanvas methodsFor: 'event handling' stamp: ''!
handleMouseOver: anEvent
	anEvent wasHandled ifTrue:[ ^ self ]. "not interested"
	(anEvent hand hasSubmorphs) ifTrue:[ ^ self ].

	anEvent hand newKeyboardFocus: self.
	self mouseOver: anEvent 
! !

!MOCanvas methodsFor: 'event handling' stamp: ''!
handlesKeyboard: anEvent
	^ true! !

!MOCanvas methodsFor: 'event handling' stamp: ''!
handlesMouseDown: anEvent
	^ true! !

!MOCanvas methodsFor: 'event handling' stamp: ''!
handlesMouseOver: anEvent
	^ true! !

!MOCanvas methodsFor: 'export' stamp: ''!
imageFormForExport
	"Make all the transparent color white"
 
	| image |
	image := self imageForm. 
	image replaceColor: Color transparent withColor:  Color white..
	^ image.! !

!MOCanvas methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	currentPosition := 0@0! !

!MOCanvas methodsFor: 'initialization' stamp: ''!
initializeHanders
	"The canvas need to listen at zoom and drag event. This is necessary to make the canvas grow"
	"The root announcer is used for this"

	| rootAnnouncer |
	self root ifNil: [self error: 'The root must be set before calling this method'].
	self root announcer ifNil: [self error: 'the root announcer must not be nil'].
	
	rootAnnouncer := self root announcer.
	rootAnnouncer on: MOZoomEvent do: [:ann | 
		ann isZoomIncrease
			ifTrue: [self extent: (self extent * 1.1)]]! !

!MOCanvas methodsFor: 'export' stamp: ''!
interactiveExportWith: imageWriterClass extension: fileExtension
	"Ask for a file name and a directory"

	| fileStream |
	fileStream := UITheme builder 
		fileSave: 'Your title here'
		extensions: #('png')
		path: nil.
		
	fileStream ifNil: [ self inform: 'saving aborded'. ^ self ].
	[ self exportWith: imageWriterClass onStream: fileStream ] 
		ensure: [ fileStream notNil ifTrue: [ fileStream close ] ]! !

!MOCanvas methodsFor: 'event handling' stamp: ''!
keyDown: anEvent
	| element |

	element := self root elementAt: anEvent position.
	element ifNotNil: [
			self announce: (MOKeyDown event: anEvent on: element).
			anEvent wasHandled: true.
			^ self ].
	
	self announce: (MOKeyDown event: anEvent on: self root).
	anEvent wasHandled: true.
! !

!MOCanvas methodsFor: 'event handling' stamp: ''!
keyStroke: anEvent

	self root hasSelection ifFalse: [ ^ self ].

"	self root selections do: [:each |
			(MOKeyPressed event: anEvent on: each) dispatch.].
"	anEvent wasHandled: true
! !

!MOCanvas methodsFor: 'event handling' stamp: ''!
keyUp: anEvent

	| element |

	element := self root elementAt: anEvent position.
	element ifNotNil: [
			self announce: (MOKeyUp event: anEvent on: element).
			anEvent wasHandled: true.
			^ self ].
	self announce: (MOKeyUp event: anEvent on: self root).
	anEvent wasHandled: true.


"	self root hasSelection ifTrue: [
		self root selections do: [:each |
			(MOKeyUp event: anEvent on: each) dispatch.].
		anEvent wasHandled: true
	]
"! !

!MOCanvas methodsFor: 'event handling' stamp: ''!
mouseDown: anEvent 
	| element |
	"anEvent wasHandled ifTrue: [ ^ self ]."
		"not interested"
"Transcript show: 'mouseDown: ', anEvent printString; cr."

	element := self root elementAt: anEvent position.
	lastEnteredGraphElement := nil.
	element ifNil: [ ^ self ].
	self announce: (MOMouseDown 
			event: anEvent
			on: element).
	anEvent wasHandled: true
! !

!MOCanvas methodsFor: 'event handling' stamp: 'BenComan 6/10/2012 02:18'!
mouseOver: anEvent 

	"not interested if already handled"
	| lastMousePosition step dragEvent elementUnderTheMouse |
	
	
	anEvent wasHandled ifTrue: [ ^ self ].
	"Transcript crShow: 'mouseOver: ', anEvent printString, ' -- ' , rubberBandStart asString , ' -- ' , rubberBandEnd asString."

	lastMousePosition := currentPosition.
	currentPosition := anEvent position - self bounds origin.
	
	((currentPosition = lastMousePosition) and: [anEvent anyButtonPressed not])
		ifTrue: [ anEvent wasHandled: true. ^ self ].
	
	
	"Check whether we are dragging a figure"
	(anEvent anyButtonPressed and: [ lastEnteredGraphElement notNil ]) ifTrue: 
		[ step := currentPosition - lastMousePosition.

		"We need to enlarge the canvas is necessary. 
			We assume here that only the lower bounds is interesting. 
			This might not be true all the time, but this could be fixed later on. 	
			We enlarge the canvas if currentPosition is close to the canvas boundary"
		"This should be done as an event that is received, and not here"
		"(self bounds containsPoint: currentPosition) 
			ifFalse: [ self extent: self extent + (step * 3) ]."
		
		step ~= (0 @ 0) ifTrue: 
			[ dragEvent := (MOMouseDrag event: anEvent on: lastEnteredGraphElement) step: step.
			  self announce: dragEvent.
			  "Do we really need to send the event to the root?"
			  "self root announce: dragEvent" ].
		anEvent wasHandled: true.
		^ self ].

	"We also need to take care of emitting leaving and entering events. A question one may ask, is why do we have to deal with entering and leaving in this mouseOver: method? The answer is the fact that figures are not morphes. The mouseOver: is invoked for entering the MOCanvas."
	elementUnderTheMouse := self root elementAt: currentPosition.

	elementUnderTheMouse ~~ lastEnteredGraphElement 
		ifTrue: [ lastEnteredGraphElement 
						ifNotNil: [ lastEnteredGraphElement resetMetricCaches.
								  self announce: 
												(MOMouseLeave event: anEvent on: lastEnteredGraphElement) ].
		  			elementUnderTheMouse 
						ifNotNil: [ 
							elementUnderTheMouse resetMetricCaches.
							self announce: (MOMouseEnter event: anEvent on: elementUnderTheMouse) ].
		  			lastEnteredGraphElement := elementUnderTheMouse ]
		ifFalse: [ self announce: (MOMouseMove event: anEvent on: elementUnderTheMouse) ].
	
	anEvent wasHandled: true! !

!MOCanvas methodsFor: 'event handling' stamp: 'BenComan 6/10/2012 02:01'!
mouseUp: anEvent 
	| element selectionEvent fromElement |

	element := self root elementAt: anEvent position.
		
	"If we have been dragging, then we shouldn't need to look for a preceeding click."
	rubberBandStart ifNotNil:
	[	
		fromElement := self root elementAt: rubberBandStart.			
		element ifNotNilDo: [:el | el announce: (MOMouseDrop event: anEvent on: el ) ].
		rubberBandStart := nil.
	].

	(lastClickPosition = anEvent position and: 
		[ lastClickTimestamp notNil and: [ lastClickTimestamp + 300 > Time millisecondClockValue ] ]) 
				ifTrue: [ ^ self announce: (MOMouseDouble event: anEvent on: element) ].
	lastClickPosition := anEvent position.
	lastClickTimestamp := Time millisecondClockValue.

	anEvent wasHandled: true.
	"Transcript crShow: 'mouseUp2: ', anEvent printString ,  ' -- ' , rubberBandStart asString , ' -- ' , rubberBandEnd asString.."
	
	"If the lastEnteredGraphElement is not selected, then we select it since a mouse button is pressed"
	(lastEnteredGraphElement isNil not and: [
		(lastEnteredGraphElement class ~~ MORoot and: [ lastEnteredGraphElement isNotSelected ])]) ifTrue: [
		selectionEvent := MOElementSelection event: anEvent on: lastEnteredGraphElement.
		anEvent commandKeyPressed ifTrue: [ selectionEvent setAsMultiple ].
	  self announce: selectionEvent.
	  anEvent wasHandled: true.
	  ^ self  ].
	"Transcript crShow: 'mouseUp3: ', anEvent printString ,  ' -- ' , rubberBandStart asString , ' -- ' , rubberBandEnd asString.."

	"We simply send MOMouseUp"
	element ifNotNilDo: [:el | el announce: (MOMouseUp event: anEvent on: el) ]! !

!MOCanvas methodsFor: 'printing' stamp: ''!
printOn: stream
	stream nextPutAll: 'MOCanvas<'.
	stream nextPutAll: self bounds printString.
	stream nextPutAll: '>'.! !

!MOCanvas methodsFor: 'error management' stamp: ''!
raiseError: error
	| v |
	v := Smalltalk at: #MondrianError ifAbsentPut: [ true ].
	v ifFalse: [ ^ self ].
	self inform: error printString.
	Smalltalk at: #MondrianError put: false! !

!MOCanvas methodsFor: 'accessing' stamp: ''!
root
	^ root! !

!MOCanvas methodsFor: 'accessing' stamp: ''!
root: aMORoot 
	root := aMORoot applyLayout.
	aMORoot canvas: self.
	"self extent: aMORoot bounds extent"
	self updateBounds! !

!MOCanvas methodsFor: 'event handling' stamp: 'BenComan 6/10/2012 01:38'!
rubberBand: aPoint
	"This method is called repetitively from MOAnnouncer>>rubberBandFromMe with position of moving mouse."
	aPoint ifNil: [ ^ rubberBandStart := nil ].
	rubberBandEnd := aPoint.
	rubberBandStart ifNil: [ rubberBandStart := aPoint ].
! !

!MOCanvas methodsFor: 'event handling' stamp: ''!
selected: anElement 
	self root deselectAll.
	anElement isNil
		ifFalse: [ anElement select ].
	self changed! !

!MOCanvas methodsFor: 'announce' stamp: ''!
signalWindowSwitch
	"This method is called when the window in which I am embedded is moved to the back or to the front"
	
	"nil is provided since no mouse event is accessible (hooks need to be inserted into the Morphic framework, which is not trivial). However, the morphic mouse event is irrelevent here"
	lastEnteredGraphElement 
		ifNotNil: [ self announce: (MOMouseLeave event: nil on: lastEnteredGraphElement) ].
	lastEnteredGraphElement := nil.! !

!MOCanvas methodsFor: 'action' stamp: ''!
stopAllProcesses
	self root allNodesDo: [ :n | n interaction stopProcesses ].
	(Process allInstances select: [:p | p name = 'mondrian process' ])
		do: #terminate.! !

!MOCanvas methodsFor: 'action' stamp: ''!
updateBounds

	"Scroll pane comes with its own bag of mysteries and tricks. "
	| scrollPane scrollPaneExtent |
	(owner isNil or: [ owner owner isNil]) 
		ifTrue: [ self extent: root bounds extent. ^ self ].
	

	scrollPane := owner owner.
	scrollPaneExtent := scrollPane bounds extent.

	scrollPane resizeScrollBars; resizeScroller; hideOrShowScrollBars.	
	scrollPane  vSetScrollDelta ; hSetScrollDelta.
	 self extent: root bounds extent.  
	

! !

MOCanvas subclass: #MOPopupViewCanvas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Pharo-Morphic'!

!MOViewRenderer methodsFor: '*mondrian-pharo-morphic' stamp: ''!
asMorph

	| pane canvas |
	pane := ScrollPane new.
	canvas := MOCanvas on: self root.
	pane scroller addMorph: canvas.
	^ (MOCanvas on: self root) updateBounds; yourself.! !

!MOViewRenderer methodsFor: '*mondrian-pharo-morphic' stamp: ''!
browserClass
	^ MOBrowser! !

!MOViewRenderer methodsFor: '*mondrian-pharo-morphic' stamp: ''!
canvas

	| canvas |
	canvas := MOCanvas new root: root.
	canvas initializeHanders.
	^ canvas! !

!MOViewRenderer methodsFor: '*mondrian-pharo-morphic' stamp: 'AlexandreBergel 4/15/2012 21:17'!
open
	self getRenderedForm.
	self root resetFormCacheRecursively; resetElementsToDisplayCache.
	^ self open: self browserClass new! !

!MOViewRenderer methodsFor: '*mondrian-pharo-morphic' stamp: ''!
open: browser
	"this subscription is triggered by updateWindow"
	| systemWindow |

	browser root: root.
	
	"Ugly"
	self userCommands do: [:assoc | browser addUserCommand: assoc ].

	systemWindow := browser open.
	self setDefaultHandlers.
	self setDefaultHandlerForWindow: systemWindow.
	browser canvas initializeHanders.
	browser canvas updateBounds.
	systemWindow setLabel: self title.

	^ systemWindow! !
